IOFacade Class Reference
The Facade Module | The Input/Output Module

A facade for input and output of mathematical objects. More...

`#include <IOFacade.h>`

Inheritance diagram for IOFacade:

## Public Member Functions

| IOFacade (bool printActions)
bool | isValidMonomialIdealFormat (const string &format)
void | readSatBinomIdeal (Scanner &in, SatBinomConsumer &consumer)
| Read a saturated binomial ideal from in and feed it to consumer.
void | readSatBinomIdeal (Scanner &in, SatBinomIdeal &ideal)
| Read a saturated binomial ideal from in and place it in the parameter ideal.
void | readIdeal (Scanner &in, BigTermConsumer &consumer)
| Read an ideal from in and feed it to consumer.
void | readIdeal (Scanner &in, BigIdeal &ideal)
| Read an ideal from in and place it in the parameter ideal.
void | readSquareFreeIdeal (Scanner &in, SquareFreeIdeal &ideal)
| Read a square free ideal from in and place it in the parameter ideal.
void | readIdeals (Scanner &in, vector< BigIdeal * > &ideals, VarNames &names)
| Insert the ideals that are read into the parameter ideals.
void | writeIdeal (const BigIdeal &ideal, IOHandler *handler, FILE *out)
void | writeIdeals (const vector< BigIdeal * > &ideals, const VarNames &names, IOHandler *handler, FILE *out)
void | readPolynomial (Scanner &in, BigPolynomial &polynomial)
void | writePolynomial (const BigPolynomial &polynomial, IOHandler *handler, FILE *out)
void | writeTerm (const vector< mpz_class > &term, const VarNames &names, IOHandler *handler, FILE *out)
void | readFrobeniusInstance (Scanner &in, vector< mpz_class > &instance)
void | readFrobeniusInstanceWithGrobnerBasis (Scanner &in, BigIdeal &ideal, vector< mpz_class > &instance)
void | writeFrobeniusInstance (FILE *out, vector< mpz_class > &instance)
bool | readAlexanderDualInstance (Scanner &in, BigIdeal &ideal, vector< mpz_class > &term)
void | readVector (Scanner &in, vector< mpz_class > &v, size_t integerCount)
bool | isValidLatticeFormat (const string &format)
void | readLattice (Scanner &in, BigIdeal &ideal)
void | writeLattice (FILE *out, const BigIdeal &ideal, const string &format)

## Additional Inherited Members

Private Member Functions inherited from Facade
| Facade (bool printActions)
| Constructs a facade that prints out what it is doing if printActions is true.
virtual | ~Facade ()
void | printMessage (const char *message)
| Prints message to standard error if printing is turned on.
void | beginAction (const char *message)
| Prints message to standard error if printing is turned on, and records the time when the action started.
void | endAction ()
| Prints to standard error the time since the last call to beginAction.
bool | isPrintingActions () const
| Returns true if printing actions.

## Detailed Description

A facade for input and output of mathematical objects.

@TODO: Consider letting Scanner play the role of IOFacade.

Definition at line 39 of file IOFacade.h.

## Constructor & Destructor Documentation

## IOFacade()

IOFacade::IOFacade | ( | bool | printActions | ) |

Definition at line 38 of file IOFacade.cpp.

## Member Function Documentation

## isValidLatticeFormat()

bool IOFacade::isValidLatticeFormat | ( | const string & | format | ) |

Definition at line 318 of file IOFacade.cpp.

## isValidMonomialIdealFormat()

bool IOFacade::isValidMonomialIdealFormat | ( | const string & | format | ) |

Definition at line 42 of file IOFacade.cpp.

## readAlexanderDualInstance()

bool IOFacade::readAlexanderDualInstance | ( | Scanner & | in,
|  | BigIdeal & | ideal,
|  | vector< mpz_class > & | term )

Definition at line 229 of file IOFacade.cpp.

## readFrobeniusInstance()

void IOFacade::readFrobeniusInstance | ( | Scanner & | in,
|  | vector< mpz_class > & | instance )

Definition at line 266 of file IOFacade.cpp.

## readFrobeniusInstanceWithGrobnerBasis()

void IOFacade::readFrobeniusInstanceWithGrobnerBasis | ( | Scanner & | in,
|  | BigIdeal & | ideal,
|  | vector< mpz_class > & | instance )

Definition at line 275 of file IOFacade.cpp.

## readIdeal() [1/2]

void IOFacade::readIdeal | ( | Scanner & | in,
|  | BigIdeal & | ideal )

Read an ideal from in and place it in the parameter ideal.

Definition at line 98 of file IOFacade.cpp.

## readIdeal() [2/2]

void IOFacade::readIdeal | ( | Scanner & | in,
|  | BigTermConsumer & | consumer )

Read an ideal from in and feed it to consumer.

Definition at line 81 of file IOFacade.cpp.

## readIdeals()

void IOFacade::readIdeals | ( | Scanner & | in,
|  | vector< BigIdeal * > & | ideals,
|  | VarNames & | names )

Insert the ideals that are read into the parameter ideals.

The parameter ideals is required to be empty. Names contains the last ring read, even if there are no ideals.

Definition at line 132 of file IOFacade.cpp.

## readLattice()

void IOFacade::readLattice | ( | Scanner & | in,
|  | BigIdeal & | ideal )

Definition at line 328 of file IOFacade.cpp.

## readPolynomial()

void IOFacade::readPolynomial | ( | Scanner & | in,
|  | BigPolynomial & | polynomial )

Definition at line 192 of file IOFacade.cpp.

## readSatBinomIdeal() [1/2]

void IOFacade::readSatBinomIdeal | ( | Scanner & | in,
|  | SatBinomConsumer & | consumer )

Read a saturated binomial ideal from in and feed it to consumer.

Definition at line 57 of file IOFacade.cpp.

## readSatBinomIdeal() [2/2]

void IOFacade::readSatBinomIdeal | ( | Scanner & | in,
|  | SatBinomIdeal & | ideal )

Read a saturated binomial ideal from in and place it in the parameter ideal.

Definition at line 68 of file IOFacade.cpp.

## readSquareFreeIdeal()

void IOFacade::readSquareFreeIdeal | ( | Scanner & | in,
|  | SquareFreeIdeal & | ideal )

Read a square free ideal from in and place it in the parameter ideal.

Definition at line 116 of file IOFacade.cpp.

## readVector()

void IOFacade::readVector | ( | Scanner & | in,
|  | vector< mpz_class > & | v,
|  | size_t | integerCount )

Definition at line 255 of file IOFacade.cpp.

## writeFrobeniusInstance()

void IOFacade::writeFrobeniusInstance | ( | FILE * | out,
|  | vector< mpz_class > & | instance )

Definition at line 304 of file IOFacade.cpp.

## writeIdeal()

void IOFacade::writeIdeal | ( | const BigIdeal & | ideal,
|  | IOHandler * | handler,
|  | FILE * | out )

Definition at line 156 of file IOFacade.cpp.

## writeIdeals()

void IOFacade::writeIdeals | ( | const vector< BigIdeal * > & | ideals,
|  | const VarNames & | names,
|  | IOHandler * | handler,
|  | FILE * | out )

Definition at line 168 of file IOFacade.cpp.

## writeLattice()

void IOFacade::writeLattice | ( | FILE * | out,
|  | const BigIdeal & | ideal,
|  | const string & | format )

Definition at line 343 of file IOFacade.cpp.

## writePolynomial()

void IOFacade::writePolynomial | ( | const BigPolynomial & | polynomial,
|  | IOHandler * | handler,
|  | FILE * | out )

Definition at line 205 of file IOFacade.cpp.

## writeTerm()

void IOFacade::writeTerm | ( | const vector< mpz_class > & | term,
|  | const VarNames & | names,
|  | IOHandler * | handler,
|  | FILE * | out )

Definition at line 218 of file IOFacade.cpp.

The documentation for this class was generated from the following files:

- src/IOFacade.h
- src/IOFacade.cpp